config/routes.rb
Rails.application.routes.draw do
  root 'static_pages#home'
  get    'stats'            => 'static_pages#stats'
  get    'about'           => 'static_pages#about'
  get    'contact'         => 'static_pages#contact'
  get    'login'           => 'sessions#new'
  post   'login'           => 'sessions#create'
  delete 'logout'          => 'sessions#destroy'
  resources :schools, :except => [:index]
  get       'schools'          => 'schools#show', :defaults => { :id => "1" }
  resources :students
  get       'students_signup'  => 'students#new'
  get       'students_load_suggestions' => 'students#load_suggestions'
  get       'students_redirect' => 'students#redirect'
  resources :companies
  get       'companies_signup' => 'companies#new'
  resources :skills
  resources :account_activations, only: [:edit]
  resources :password_resets,     only: [:new, :create, :edit, :update]
  resources :matches
  resources :stages

end

app/models/student.rb
class Student < ActiveRecord::Base
  include MatchesModule

  attr_accessor :remember_token, :activation_token, :reset_token

  has_many :student_skills, inverse_of: :student
  has_many :skills, through: :student_skills
  has_many :matches
  has_one  :stage

  accepts_nested_attributes_for :student_skills, allow_destroy: true

  before_create :create_activation_digest
  before_save :downcase_email

  validates :name,        presence: true, length: { maximum: 50 }
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-]+(\.[a-z\d\-]+)*\.[a-z]+\z/i
  validates :email,       presence: true, length: { maximum: 255 },
                          format: { with: VALID_EMAIL_REGEX },
                          uniqueness: { case_sensitive: false }
  validates :birth_date,  presence: true
  validate  :birth_date_cannot_be_in_the_future
  validates :school_year, presence: true
  validate  :first_letter_must_be_a_school_year
  has_secure_password
  validates :password, length: { minimum: 6 }, allow_blank: true

  # Returns the hash digest of the given string.
  def Student.digest(string)
    cost = ActiveModel::SecurePassword.min_cost ? BCrypt::Engine::MIN_COST :
                                                  BCrypt::Engine.cost
    BCrypt::Password.create(string, cost: cost)
  end

  # Returns a random token.
  def Student.new_token
    SecureRandom.urlsafe_base64
  end

  # Returns true if the given token matches the digest.
  def authenticated?(attribute, token)
    digest = send("#{attribute}_digest")
    return false if digest.nil?
    BCrypt::Password.new(digest).is_password?(token)
  end

  # Remembers a student in the database for use in persistent sessions.
  def remember
    self.remember_token = Student.new_token
    update_attribute(:remember_digest, Student.digest(remember_token))
  end

  # Forgets a student
  def forget
    update_attribute(:remember_digest, nil)
  end

  # Activates an account.
  def activate
    update_attribute(:activated,    true)
    update_attribute(:activated_at, Time.zone.now)
  end

  def send_activation_email
    UserMailer.account_activation(self).deliver_now
  end

  # Sets the password reset attributes.
  def create_reset_digest
    self.reset_token = Student.new_token
    update_attribute(:reset_digest,  Student.digest(reset_token))
    update_attribute(:reset_sent_at, Time.zone.now)
  end

  # Sends password reset email.
  def send_password_reset_email
    UserMailer.password_reset(self).deliver_now
  end

  # Returns true if a password reset has expired.
  def password_reset_expired?
    reset_sent_at < 2.hours.ago
  end

  # Assigns a skill to the student.
  def assign_skill(skill, level)
    StudentSkill.create(student_id: self.id, skill_id: skill.id, level: level)
  end

  # Removes a skill from the student.
  def remove_skill(skill)
    StudentSkill.find_by(skill_id: skill.id).destroy
  end

  # Returns true if the student has the skill.
  def has_skill?(skill)
    !StudentSkill.find_by(skill_id: skill.id).nil?
  end

  def find_matches
    start = Time.now
    matches = []
    existing_matches = Match.all.where(student_id: self.id)
    Company.eager_load(:company_skills).all.each {|company| matches.push find_match(self, company,
                                                        self.student_skills,
                                                        company.company_skills,
                                                        existing_matches)}
    puts "Matches: #{matches.reject(&:blank?)}".green
    puts "Execution time: #{Time.now - start} seconds".brown
    puts "Total matches in db: #{Match.all.length}"
  end

  def self.terms_for(prefix)
    suggestions = where("name like ?", "#{prefix}_%")
    suggestions.limit(10).pluck(:name)
  end

  private

    # Returns an error if the birth date is in the future.
    def birth_date_cannot_be_in_the_future
      if birth_date.nil? || birth_date > Date.today
        errors.add(:birth_date, "can't be in the future")
      end
    end

    def first_letter_must_be_a_school_year
      initial = school_year[0,1].to_i
      second = school_year[1,2]
      if initial < 1 || initial > 5 || second.to_i > 0
        errors.add(:school_year, "must be number + letter")
      end
    end

    # Converts email to all lower-case.
    def downcase_email
      self.email = email.downcase
    end

    # Creates and assigns the activation token and digest.
    def create_activation_digest
      self.activation_token = Student.new_token
      self.activation_digest = Student.digest(activation_token)
    end

end

app/controllers/students_controller.rb
class StudentsController < ApplicationController
  include ApplicationHelper
  before_action :logged_in_user, only: [:new, :create, :index, :edit,
                                        :update, :destroy]
  before_action :correct_user,   only: [:show, :edit, :update]
  before_action :admin_user,     only: [:new, :create, :index, :destroy]

  def index
    @students = Student.order(:school_year).paginate(page: params[:page])
  end

  def show
    @student        = Student.find(params[:id])
    @student_skills = @student.student_skills
  end

  def new
    @student = Student.new
  end

  def create
    @student = Student.new(student_params)
    if does_alredy_exist? @student.email
      flash.now[:danger] = "L'email è già stata presa."
      render "new"
    elsif @student.save
      @student.send_activation_email
      flash[:info] = "E' stata inviata un'email per l'attivazione dell'account."
      redirect_to root_url
    else
      render "new"
    end
  end

  def edit
    @student = Student.find(params[:id])
    @student_skills = @student.skills
  end

  def update
    if @student.update_attributes(student_params)
      flash[:success] = "Profilo aggiornato"
      redirect_to @student
    else
      render "edit"
    end
  end

  def destroy
    Student.find(params[:id]).destroy
    flash[:success] = "Studente eliminato"
    redirect_to students_url
  end

  def update_skills
    @skills = Skill.all
    respond_to do |format|
      format.js
    end
  end

  def load_suggestions
    render json: Student.terms_for(params[:term])
  end

  def redirect
    s = Student.find_by(name: params[:name]).id
    redirect_to student_path(s) unless s.nil?
  end

  private

    def student_params
      params.require(:student).permit(:name, :email, :birth_date, :school_year,
                          :password, :password_confirmation,
                          student_skills_attributes: [:id, :skill_id, :level,
                                                      :_destroy] )
    end

    # Before filters

    # Confirms a logged-in user.
    def logged_in_user
      unless logged_in?
        store_location
        flash[:danger] = "Devi essere loggato per eseguire quest'azione."
        redirect_to login_url
      end
    end

    # Confirms the correct user (the student or the school).
    def correct_user
      @student = Student.find(params[:id])
      redirect_to(root_url) unless @student == current_user ||
                                   (current_user.is_a? School) ||
                                   (current_user.is_a? Company)
    end

    # Confirms an admin user (the school)
    def admin_user
      unless (current_user.is_a? School) && current_user.admin?
        flash[:danger] = "Devi essere loggato come admin
                          per eseguire quest'azione."
        redirect_to root_url
      end
    end

end

app/helpers/students_helper.rb
module StudentsHelper
  # Returns the Gravatar for the given user.
  def gravatar_for(user, options = { size: 80, style: "gravatar" })
    gravatar_id = Digest::MD5::hexdigest(user.email.downcase)
    size = options[:size]
    style = options[:style]
    gravatar_url = "https://secure.gravatar.com/avatar/#{gravatar_id}?s=#{size}"
    image_tag(gravatar_url, alt: user.name, class: style)
  end

  # Returns every skill that the given user doesn't have.
  def skills_not_owned(user)
    Skill.all - user.skills
  end

end

app/views/students/_student.html.erb
<li>
  <% if current_user.is_a? School %>
    <div style="display:flex">
      <div style="flex:1">
        <%= gravatar_for student, size: 50 %>
        <div style="margin-left:10px;display:inline-block"></div>
        <%= link_to student.name, student %>
      </div>
      <div style="flex:1;text-align:center">
        <%= student.school_year %>
      </div>
      <div class="settings">
        <%= link_to raw("<span class='glyphicon glyphicon-pencil'></span>"),
                    edit_student_path(student), class: "btn btn-warning" %>
        <%= link_to raw("<span class='glyphicon glyphicon-trash'></span>"),
                    student, method: :delete,
                                    data: { confirm: "Sei sicuro?" },
                                    class: "btn btn-danger" %>
      </div>
    </div>
  <% else %>
    <div style="flex:1">
      <%= gravatar_for student, size: 50 %>
      <div style="margin-left:10px;display:inline-block"></div>
      <%= link_to student.name, student %>
    </div>
    <div style="flex:1;text-align:center">
      <%= student.school_year %>
    </div>
    <div style="width:100px"></div>
  <% end %>
</li>

app/views/students/edit.html.erb
<% provide(:title, 'Modifica studente') %>
<h1>Modifica studente</h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@student) do |f| %>
      <%= render "shared/error_messages", object: f.object %>

      <%= f.label :name, "Nome" %>
      <%= f.text_field :name, class: "form-control" %>

      <%= f.label :email %>
      <%= f.email_field :email, class: "form-control" %>

      <%= f.label :birth_date, "Data di nascita" %>
      <%= f.text_field :birth_date, class: "form-control" %>

      <%= f.label :school_year, "Classe" %>
      <%= f.text_field :school_year, class: "form-control" %>

      <%= f.label :password %>
      <%= f.password_field :password, class: "form-control" %>

      <%= f.label :password_confirmation, "Conferma password" %>
      <%= f.password_field :password_confirmation, class: "form-control" %>

      <% if current_user.is_a? School %>
      <div id="show-hint" class="btn btn-link">Tabella dei livelli di competenza</div>

      <div style="display:flex">
        <div style="flex:7;margin-right:5px">
          <%= f.label :student_skills, "Competenze" %>
          <%= select_tag :student_skills,
                    options_from_collection_for_select(
                            skills_not_owned(@student).sort_by{|obj| obj.name},
                                             "id", "name"),
                    { class: "form-control" } %>
        </div>
        <div style="flex:1;margin-right:5px">
          <label for="skill_level">Livello:</label>
          <input type="number" class="form-control"
                               id="skill_level" name="skill_level" value="1" />
        </div>
        <div style="margin-top:25px;height:34px;" class="btn btn-success"
                                                  id="add_skill">+</div>
      </div>
        <ul class="list-group" id="skills-list">
          <%= f.fields_for :student_skills do |s| %>
            <li class="list-group-item">
              <div class="skill-entry">
                <%= Skill.find(s.object.skill_id).name %>
              </div>
              <%= s.number_field :level, class: "form-control skill-level" %>
              <%= s.hidden_field :_destroy %>
              <div class="remove_skill btn btn-danger">-</div>
            </li>
          <% end %>
        </ul>
      <% end %>

      <%= f.submit "Salva i cambiamenti", class: "btn btn-primary" %>
    <% end %>
    <div class="gravatar_edit">
      <%= gravatar_for @student %>
      <a href="http://gravatar.com/emails" target=_blank>cambia</a>
    </div>

  </div>
</div>


<div id="skill-hint-overlay">
  <div id="skill-hint-container">
    <div style="margin-bottom:10px;">
      <div style="float:left"><b>Descrizione dei livelli di competenza</b></div>
      <div id="close-hint" style="float:right;cursor:pointer">X</div>
      <div style="clear:both"></div>
    </div>
    <table border="1">
      <tr><th>Livello</th><th>Descrizione</th></tr>
      <tr><td>1</td>
        <td><ul>
            <li>Opera sotto supervisione di altri in situazioni ricorrenti;</li>
            <li>
              Conoscenza degli elementi costitutivi e delle caratteristiche di
              base della materia/tecnica, dal punto di vista teorico e generale.
            </li>
          </ul></td></tr>
      <tr><td>2</td>
        <td><ul>
            <li>Opera autonomamente in situazioni ricorrenti;</li>
            <li>Opera sotto la supervisione di altri in situazioni mediamente complesse;</li>
            <li>
              Conoscenza della materia sufficiente a comprenderne l’applicazione
              e ad utilizzare sul lavoro come è acquisibile con esperienze
              professionali di base.
            </li>
          </ul></td></tr>
      <tr><td>3</td>
        <td><ul>
            <li>Opera autonomamente in situazioni mediamente complesse;</li>
            <li>
              Opera con l’indirizzo e/o la supervisione di altri in situazioni complesse;
            </li>
            <li>
              Conoscenza della materia/tecnica adeguata e tale da comprenderne
              l’applicazione e ad utilizzare in modo completo sul lavoro come è
              acquisibile con esperienze professionali diverse maturate nel tempo.
            </li>
          </ul></td></tr>
      <tr><td>4</td>
        <td><ul>
            <li>Opera in autonomia in situazioni complesse;</li>
            <li>
              Conoscenza che permette di operare pienamente e produrre risultati
              completi, come è acquisibile dallo svolgimento di attività nella
              specifica area professionale o in altre collegate.
            </li>
          </ul></td></tr>
      <tr><td>5</td>
        <td><ul>
            <li>Opera in autonomia in situazioni di elevata complessità;</li>
            <li>
              Conoscenza elevata della materia/tecnica, frutto di studi, ampie
              esperienze di lavoro nella specifica area professionale e in
              altre, che consente risultati di lavoro rilevanti.
            </li>
          </ul></td></tr>
    </table>
  </div>
</div>

app/views/students/index.html.erb
<% provide(:title, 'Tutti gli studenti') %>
<h1>Tutti gli studenti</h1>

<% if current_user.is_a? School %>
  <div style="display:flex">
    <div style="flex:6">
      <%= will_paginate %>
    </div>

    <div class="ui-widget v-align" style="flex:3; margin:15px 50px 0 0;">
      <label style="margin: -15px 10px 0 0;" for="search">Cerca</label>
      <input id="search" class="form-control">
      <div class="btn btn-primary" id="goStudent" style="margin: -15px 10px 0 10px;">
        <span class="glyphicon glyphicon-search" aria-hidden="true"></span>
      </div>
    </div>

    <div class="v-align" style="flex:1">
      <%= link_to "+ Nuovo studente", students_signup_path,
                                      class: "btn btn-success" %>
    </div>
  </div>
<% else %>
  <%= will_paginate %>
<% end %>

<ul class="users">
  <li>
    <div style="display:flex">
      <div style="flex:1"><b>Nome</b></div>
      <div style="flex:1;text-align:center"><b>Classe</b></div>
      <div style="width:100px;"></div>
    </div>
  </li>
  <%= render @students %>
</ul>

<%= will_paginate %>

app/views/students/new.html.erb
<% provide(:title, 'Nuovo studente') %>
<h1>Nuovo studente</h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@student) do |f| %>
      <%= render "shared/error_messages", object: f.object %>

      <%= f.label :name, "Nome" %>
      <%= f.text_field :name, class: "form-control" %>

      <%= f.label :email %>
      <%= f.email_field :email, class: "form-control" %>

      <%= f.label :birth_date, "Data di nascita" %>
      <%= f.text_field :birth_date, class: "form-control" %>

      <%= f.label :school_year, "Classe" %>
      <%= f.number_field :school_year, class: "form-control" %>

      <div style="display:flex">
        <div style="flex:1">
          <%= f.label :password %>
          <%= f.text_field :password, class: "form-control" %>
        </div>
        <div style="display:flex; align-self:center; margin-top:10px;margin-left:10px;">
          <div id="genpw-btn" class="btn btn-warning">Genera password</div>
        </div>
      </div>

      <%= f.label :password_confirmation, "Conferma password" %>
      <%= f.text_field :password_confirmation, class: "form-control" %>
      <hr>
      <div id="show-hint" class="btn btn-link">Tabella dei livelli di competenza</div>
      <div style="display:flex">
        <div style="flex:7;margin-right:5px">
          <%= f.label :student_skills, "Competenze" %>
          <%= select_tag :student_skills,
                    options_from_collection_for_select(
                               Skill.all.sort_by{|obj| obj.name}, "id", "name"),
                    { class: "form-control" } %>
        </div>
        <div style="flex:1;margin-right:5px">
          <label for="skill_level">Livello:</label>
          <input type="number" class="form-control"
                               id="skill_level" name="skill_level" value="1" />
        </div>
        <div style="margin-top:25px;height:34px;" class="btn btn-success"
                                                  id="add_skill">+</div>
      </div>

      <ul class="list-group" id="skills-list"></ul>

      <%= f.submit "Crea studente", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

<div id="skill-hint-overlay">
  <div id="skill-hint-container">
    <div style="margin-bottom:10px;">
      <div style="float:left"><b>Descrizione dei livelli di competenza</b></div>
      <div id="close-hint" style="float:right;cursor:pointer">X</div>
      <div style="clear:both"></div>
    </div>
    <table border="1">
      <tr><th>Livello</th><th>Descrizione</th></tr>
      <tr><td>1</td>
        <td><ul>
            <li>Opera sotto supervisione di altri in situazioni ricorrenti;</li>
            <li>
              Conoscenza degli elementi costitutivi e delle caratteristiche di
              base della materia/tecnica, dal punto di vista teorico e generale.
            </li>
          </ul></td></tr>
      <tr><td>2</td>
        <td><ul>
            <li>Opera autonomamente in situazioni ricorrenti;</li>
            <li>Opera sotto la supervisione di altri in situazioni mediamente complesse;</li>
            <li>
              Conoscenza della materia sufficiente a comprenderne l’applicazione
              e ad utilizzare sul lavoro come è acquisibile con esperienze
              professionali di base.
            </li>
          </ul></td></tr>
      <tr><td>3</td>
        <td><ul>
            <li>Opera autonomamente in situazioni mediamente complesse;</li>
            <li>
              Opera con l’indirizzo e/o la supervisione di altri in situazioni complesse;
            </li>
            <li>
              Conoscenza della materia/tecnica adeguata e tale da comprenderne
              l’applicazione e ad utilizzare in modo completo sul lavoro come è
              acquisibile con esperienze professionali diverse maturate nel tempo.
            </li>
          </ul></td></tr>
      <tr><td>4</td>
        <td><ul>
            <li>Opera in autonomia in situazioni complesse;</li>
            <li>
              Conoscenza che permette di operare pienamente e produrre risultati
              completi, come è acquisibile dallo svolgimento di attività nella
              specifica area professionale o in altre collegate.
            </li>
          </ul></td></tr>
      <tr><td>5</td>
        <td><ul>
            <li>Opera in autonomia in situazioni di elevata complessità;</li>
            <li>
              Conoscenza elevata della materia/tecnica, frutto di studi, ampie
              esperienze di lavoro nella specifica area professionale e in
              altre, che consente risultati di lavoro rilevanti.
            </li>
          </ul></td></tr>
    </table>
  </div>
</div>

app/views/students/show.html.erb
<% provide(:title, @student.name) %>
<h1>
  <%= gravatar_for @student, { style: "" } %>
  <%= @student.name %>
</h1>
<div class="row" style="margin-top: 20px;">
  <div class="col-md-3">
    <h3>Email</h3>
    <%= @student.email %> <br>
    <h3 style="margin-top:25px">Data di nascita</h3>
    <%= @student.birth_date %> <br>
    <h3 style="margin-top:25px">Classe</h3>
    <%= @student.school_year %>
    <% if !@student.activated? %>
      <div style="color:#c55;font-weight:bold">Account non attivato</div>
    <% end %>
    <br> <br>
    <%= link_to "Modifica", edit_student_path(@student),
                               class: "btn btn-warning" %>
  </div>

  <section class="col-md-9">
    <ul class="users">
      <li>
        <div style="display:flex">
          <div style="flex:7">
            <b>Competenza</b>
          </div>
          <div style="flex:1;text-align:center">
            <b>Livello</b>
          </div>
      </li>
      <%= render @student_skills %>
    </ul>
  </section>
</div>